<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>For Each Sample</title>

    <!-- CDN of bootstrap -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
        integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">

    <script src="https://kit.fontawesome.com/887a516220.js" crossorigin="anonymous"></script>
</head>
<body>
    <div class="container">

        <h1>ForEach Samples</h1>
        <br/>

        <h2>Four ways to do the same table</h2>
        <br/>

        <h3>ForEach with anonymous function</h3>
        <table class="table table-dark">
            <thead>
                <tr>
                    <th>Name</th>
                    <th>Category</th>
                    <th>Start</th>
                    <th>End</th>
                </tr>
            </thead>
            <tbody id="anonymousRows">
            </tbody>
        </table>
        <br/>

        <h3>ForEach with arrow function</h3>
        <table class="table">
            <thead class="thead-light">
                <tr>
                    <th>Name</th>
                    <th>Category</th>
                    <th>Start</th>
                    <th>End</th>
                </tr>
            </thead>
            <tbody id="arrowRows" >
            </tbody>
        </table>
        <br/>

        <h3>ForEach with declared function</h3>
        <table class="table table-bordered">
            <thead>
                <tr>
                    <th>Name</th>
                    <th>Category</th>
                    <th>Start</th>
                    <th>End</th>
                </tr>
            </thead>
            <tbody id="declaredRows" >
            </tbody>
        </table>
        <br/>


        <h3>ForEach with declared arrow function</h3>
        <table class="table table-bordered table-hover">
            <thead>
                <tr>
                    <th>Name</th>
                    <th>Category</th>
                    <th>Start</th>
                    <th>End</th>
                </tr>
            </thead>
            <tbody id="declaredArrowRows" >
            </tbody>
        </table>
        <br/>



    </div>

</body>
<script>

    /*
     * companies , is an array of object
     * the attribute of each object are 
     * name, category, start, end   
     */
    const companies = [
        {name: 'Company 1', category: 'Finance', start: '1987', end : '1999'  },
        {name: 'Company 2', category: 'Autho', start: '1990', end : '2015'  },
        {name: 'Company 3', category: 'Retail', start: '1950', end : '2000'  },
        {name: 'Company 4', category: 'Technoloy', start: '1945', end : '2015'  }
    ]

    // 1) First, we define the an array (anonymousRows)
    // 2) Then we define a traditional function inside the forEach method
    // 3) The tradicional function uses a string template to build the row and string interpolation to set the values    
    // 4) Finally we set the array in the table body

    const anonymousRows =[];

    companies.forEach( function( company, index ){
        console.log(  company );        
        anonymousRows.push(`<tr>
                            <td>${company.name}</td>
                            <td>${company.category}</td>
                            <td>${company.start}</td>
                            <td>${company.end}</td>
                          </tr>`);
    });

    document.getElementById('anonymousRows').innerHTML = anonymousRows.join('');


    // 1) First, we define the an array (arrowRows)
    // 2) Then we define an arrow function inside the forEach method
    // 3) The arrow function uses a string template to build the row and string interpolation to set the values    
    // 4) Finally we set the array in the table body

    const arrowRows = [];
    
    companies.forEach( (company, index)=> {
        arrowRows.push(`<tr>
                            <td>${company.name}</td>
                            <td>${company.category}</td>
                            <td>${company.start}</td>
                            <td>${company.end}</td>
                          </tr>`);
    });
    
    document.getElementById('arrowRows').innerHTML = arrowRows.join('');

    // 1) First, we define the an array (declaredRows)
    // 2) Then we declare a traditional function (createTableRow)
    // 3) The function uses a string template to build the row and string interpolation to set the values
    // 4) The companies array use the method forEach. To execute it, the array uses the declared traditional function
    // 5) Finally we set the array in the table body

    const declaredRows = [];

    const createTableRow = function(company, index){
        declaredRows.push(`<tr>
                            <td>${company.name}</td>
                            <td>${company.category}</td>
                            <td>${company.start}</td>
                            <td>${company.end}</td>
                          </tr>`);
    }

    companies.forEach( createTableRow );
    document.getElementById('declaredRows').innerHTML = declaredRows.join('');


    // 1) First, we define the an array (declaredArrowRows)
    // 2) Then we declare an arrow function (createRow)
    // 3) The function uses a string template to build the row and string interpolation to set the values
    // 4) The companies array use the method forEach. To execute it, the array uses the declared arrow function
    // 5) Finally we set the array in the table body

    const declaredArrowRows = [];
         
    const createRow = (company, index) => {        
        declaredArrowRows.push(`<tr>
                            <td>${company.name}</td>
                            <td>${company.category}</td>
                            <td>${company.start}</td>
                            <td>${company.end}</td>
                          </tr>`);
    };
    
    companies.forEach( createRow );
    document.getElementById('declaredArrowRows').innerHTML = declaredArrowRows.join('');


</script>

</html>